SystemOrganization addCategory: #'Constraints-Tests'!
SystemOrganization addCategory: #'Constraints-Core'!

!True methodsFor: '*Constraints' stamp: 'mg 5/14/2014 11:13'!
print

	^ 'true'! !

!ClVariable methodsFor: '*Constraints' stamp: 'mg 4/17/2014 16:37'!
asConstantConstraintVariable

	^ self! !

!ClVariable methodsFor: '*Constraints' stamp: 'mg 4/17/2014 16:36'!
asConstraintVariable

	^ self! !

!False methodsFor: '*Constraints' stamp: 'mg 5/14/2014 11:12'!
print

	^ 'false'! !

Object subclass: #Constraint
	instanceVariableNames: 'solver priority constraintBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!Constraint methodsFor: 'comparing' stamp: 'mg 4/16/2014 12:02'!
< aConstraint

	self priority < aConstraint priority! !

!Constraint methodsFor: 'comparing' stamp: 'mg 4/16/2014 11:46'!
<= aConstraint

	self priority <= aConstraint priority! !

!Constraint methodsFor: 'solving' stamp: 'mg 4/30/2014 13:56'!
addConstraintsToSolver

	self solver addConstraint: self! !

!Constraint methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:57'!
constraintBlock

	^ constraintBlock! !

!Constraint methodsFor: 'accessing' stamp: 'mg 5/5/2014 15:00'!
constraintBlock: anObject

	constraintBlock := anObject! !

!Constraint methodsFor: 'solving' stamp: 'mg 5/13/2014 12:46'!
disable

	self subclassResponsibility.! !

!Constraint methodsFor: 'solving' stamp: 'mg 5/13/2014 12:46'!
enable

	self subclassResponsibility.! !

!Constraint methodsFor: 'initialize-release' stamp: 'mg 5/13/2014 12:39'!
initialize

	priority := ConstraintPriority required.! !

!Constraint methodsFor: 'comparing' stamp: 'mg 4/30/2014 15:40'!
isConstraint

	^ true! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
priority

	^ priority! !

!Constraint methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:00'!
priority: anObject
"Ths method should retract all external constraints and re-enable them using the new priority."
	priority := anObject! !

!Constraint methodsFor: 'solving' stamp: 'mg 4/30/2014 14:38'!
removeConstraintsFromSolver

	self solver removeConstraint: self! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
solver

	^ solver! !

!Constraint methodsFor: 'accessing' stamp: 'mg 5/13/2014 12:47'!
solver: anObject

	solver := anObject! !

!Constraint methodsFor: 'solving' stamp: 'mg 4/23/2014 14:01'!
triggerSolver
	"This method should be called, if this constraint changed, e.g., because a variable changed. It triggers the solver to solve all constraints. The solving process may raise an exception, if the constraints are unsatisfiable."
	self solver solve.
! !

Constraint subclass: #ConstraintCassowary
	instanceVariableNames: 'externalConstraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintCassowary methodsFor: 'accessing' stamp: 'mg 5/14/2014 13:22'!
addExpression: aConstraintExpression

	aConstraintExpression isBinaryExpression
		ifTrue: [self addExpression: aConstraintExpression leftSide.
				self addExpression: aConstraintExpression rightSide]
		ifFalse: [self addExternalConstraint: aConstraintExpression externalConstraintExpression].! !

!ConstraintCassowary methodsFor: 'accessing' stamp: 'mg 4/30/2014 15:45'!
addExternalConstraint: anExternalConstraint

	self externalConstraints add: anExternalConstraint.! !

!ConstraintCassowary methodsFor: 'solving' stamp: 'mg 5/5/2014 11:33'!
disable

	self externalConstraints 
		ifNotEmpty: [self removeConstraintsFromSolver]
		ifEmpty: [Transcript show: 'WARNING - There is no constraint to disable.'; cr].! !

!ConstraintCassowary methodsFor: 'solving' stamp: 'mg 5/5/2014 11:06'!
enable

	self externalConstraints 
		ifNotEmpty: [self addConstraintsToSolver]
		ifEmpty: [Transcript show: 'WARNING - There is no constraint to enable.'; cr.].! !

!ConstraintCassowary methodsFor: 'accessing' stamp: 'mg 4/30/2014 15:44'!
externalConstraints

	^ externalConstraints! !

!ConstraintCassowary methodsFor: 'initialize-release' stamp: 'mg 5/13/2014 12:39'!
initialize

	super initialize.
	externalConstraints := OrderedCollection new.! !

!ConstraintCassowary methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:00'!
priority: anObject 
"Ths method should retract all external constraints and re-enable them using the new priority."
	priority := anObject.
	self solver
		ifNotNil: [self removeConstraintsFromSolver.
			self externalConstraints
				do: [:extConstraint | extConstraint strength: anObject asCassowaryStrength].
			self addConstraintsToSolver]! !

Constraint subclass: #ConstraintZ3
	instanceVariableNames: 'expressions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintZ3 methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:49'!
addExpression: aConstraintExpression

	self expressions add: aConstraintExpression.! !

!ConstraintZ3 methodsFor: 'solving' stamp: 'mg 5/13/2014 13:08'!
disable

	self expressions 
		ifNotEmpty: [self removeConstraintsFromSolver]
		ifEmpty: [Transcript show: 'WARNING - There is no constraint to disable.'; cr].! !

!ConstraintZ3 methodsFor: 'solving' stamp: 'mg 5/13/2014 13:07'!
enable

	self expressions 
		ifNotEmpty: [self addConstraintsToSolver]
		ifEmpty: [Transcript show: 'WARNING - There is no constraint to enable.'; cr.].! !

!ConstraintZ3 methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:05'!
expressions

	^ expressions! !

!ConstraintZ3 methodsFor: 'initialize-release' stamp: 'mg 5/13/2014 13:06'!
initialize

	super initialize.
	expressions := OrderedCollection new.! !

!ConstraintZ3 methodsFor: 'printing' stamp: 'mg 5/13/2014 13:22'!
print

	| exprString |
	exprString := ''.
	self expressions do: [:expr | exprString := exprString, '(assert ', expr print, ')', Character cr].
	^ exprString! !

!ConstraintZ3 methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:03'!
priority: anObject 
"Ths method should retract all external constraints and re-enable them using the new priority."
	anObject = ConstraintPriority required
		ifFalse: [self error: 'The priority of a Z3 constraint must be required. Soft constraints are not supported yet.'].! !

Object subclass: #ConstraintExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

ConstraintExpression subclass: #ConstraintBinaryExpression
	instanceVariableNames: 'operator leftSide rightSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:54'!
& x

	^ ConstraintBinaryExpression new
			operator: 'and';
			leftSide: self;
			rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/13/2014 14:44'!
* x

	^ ConstraintBinaryExpression new
			operator: '*';
			leftSide: self;
			rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/13/2014 14:44'!
+ x

	^ ConstraintBinaryExpression new
			operator: '+';
			leftSide: self;
			rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/13/2014 14:44'!
- x

	^ ConstraintBinaryExpression new
			operator: '-';
			leftSide: self;
			rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/13/2014 14:45'!
/ x

	^ ConstraintBinaryExpression new
			operator: '/';
			leftSide: self;
			rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:57'!
< x

	^ ConstraintBinaryExpression new
		operator: '<';
		leftSide: self;
		rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:53'!
<= x

	^ ConstraintBinaryExpression new
		operator: '<=';
		leftSide: self;
		rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:53'!
= x

	^ ConstraintBinaryExpression new
		operator: '=';
		leftSide: self;
		rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:57'!
> x

	^ ConstraintBinaryExpression new
		operator: '>';
		leftSide: self;
		rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:53'!
>= x

	^ ConstraintBinaryExpression new
		operator: '>=';
		leftSide: self;
		rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:37'!
cos

	^ (self + Float halfPi) sin! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 10:57'!
isBinaryExpression

	^ true! !

!ConstraintBinaryExpression methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:17'!
leftSide

	^ leftSide! !

!ConstraintBinaryExpression methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:17'!
leftSide: anObject

	leftSide := anObject! !

!ConstraintBinaryExpression methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:17'!
operator

	^ operator! !

!ConstraintBinaryExpression methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:17'!
operator: anObject

	operator := anObject! !

!ConstraintBinaryExpression methodsFor: 'printing' stamp: 'mg 5/26/2014 11:55'!
print

	^ '(', self operator, ' ', self leftSide print, ' ', self rightSide print, ')'! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:14'!
raisedTo: x

	^ ConstraintBinaryExpression new
			operator: '^';
			leftSide: self;
			rightSide: x! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:37'!
raisedToInteger: x

	^ self raisedTo: x! !

!ConstraintBinaryExpression methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:17'!
rightSide

	^ rightSide! !

!ConstraintBinaryExpression methodsFor: 'accessing' stamp: 'mg 5/13/2014 13:17'!
rightSide: anObject

	rightSide := anObject! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:20'!
sin

	^ self 
		- ((self raisedTo: 3) / 6) 
		+ ((self raisedTo: 5) / 120)
		- ((self raisedTo: 7) / 5040) 
		+ ((self raisedTo: 9) / 362880)
		- ((self raisedTo: 11) / 39916800) 
		+ ((self raisedTo: 13) /  6227020800)
		- ((self raisedTo: 15) /  1307674368000) 
		+ ((self raisedTo: 17) /  355687428096000)! !

!ConstraintBinaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:37'!
squared

	^ self raisedTo: 2! !

ConstraintExpression subclass: #ConstraintCassowaryExpression
	instanceVariableNames: 'externalConstraintExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintCassowaryExpression commentStamp: 'mg 5/14/2014 12:36' prior: 0!
A ConstraintZ3Expression represents a Cassowary constraint.

Instance Variables
	externalConstraintExpression:		aClLinearEquation
!

!ConstraintCassowaryExpression methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:54'!
& aConstraintExpression
	"The argument should evaluate to a boolean, so it must be a constraint expression."
	aConstraintExpression isConstraintExpression
		ifFalse: [self error: 'Cannot conjugate a constraint expression with something else than a constraint expression.'].
	^ ConstraintBinaryExpression new
			operator: 'and';
			leftSide: self;
			rightSide: aConstraintExpression! !

!ConstraintCassowaryExpression methodsFor: 'accessing' stamp: 'mg 5/14/2014 12:31'!
externalConstraintExpression

	^ externalConstraintExpression! !

!ConstraintCassowaryExpression methodsFor: 'accessing' stamp: 'mg 5/14/2014 12:31'!
externalConstraintExpression: anObject

	externalConstraintExpression := anObject! !

ConstraintExpression subclass: #ConstraintCollectionExpression
	instanceVariableNames: 'expressions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintCollectionExpression methodsFor: 'accessing' stamp: 'mg 5/27/2014 14:59'!
expressions

	^ expressions! !

!ConstraintCollectionExpression methodsFor: 'initialize-release' stamp: 'mg 5/27/2014 15:19'!
initialize

	expressions := OrderedCollection new.! !

!ConstraintCollectionExpression methodsFor: 'comparing' stamp: 'mg 5/27/2014 15:03'!
isConstraintCollectionExpression

	^ true! !

!ConstraintCollectionExpression methodsFor: 'printing' stamp: 'mg 5/27/2014 15:33'!
print

	| expressionString |
	expressionString := ''.
	(1 to: self expressions size - 1) 
		do: [:index | | expr | 
			expr := self expressions at: index.
			expressionString := expressionString, expr print, ')', Character cr, '(assert '].
	expressionString := expressionString, self expressions last print.
	^ expressionString! !

!ConstraintExpression methodsFor: 'as yet unclassified' stamp: 'mg 5/14/2014 13:53'!
addExpressionToConstraint: aConstraint

	aConstraint addExpression: self! !

!ConstraintExpression methodsFor: 'comparing' stamp: 'mg 5/27/2014 15:03'!
isConstraintCollectionExpression

	^ false! !

!ConstraintExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 12:54'!
isConstraintExpression

	^ true! !

ConstraintExpression subclass: #ConstraintLinearExpression
	instanceVariableNames: 'externalExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintLinearExpression commentStamp: 'mg 5/14/2014 12:36' prior: 0!
A ConstraintLinearExpression is linear and it is no equation. So, a ConstraintLinearExpression cannot be used as a constraint. It should get the message <=, = or >= to transform itself into a ConstraintZ3Expression, which is a constraint.

Instance Variables
	externalExpression:		aClLinearExpression
!

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 4/24/2014 11:02'!
* x

	^ ConstraintLinearExpression new
		externalExpression: self externalExpression * x asConstantConstraintVariable value! !

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 12:38'!
+ x

	| expr |
	expr := x asConstraintLinearExpression.
	^ ConstraintLinearExpression new
		externalExpression: self externalExpression + expr externalExpression! !

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 12:39'!
- x

	| expr |
	expr := x asConstraintLinearExpression.
	^ ConstraintLinearExpression new
		externalExpression: self externalExpression - expr externalExpression! !

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 4/24/2014 12:44'!
/ x

	^ ConstraintLinearExpression new
		externalExpression: self externalExpression / x asConstantConstraintVariable value! !

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 12:42'!
<= x

	| expr extConstraint |
	expr := x asConstraintLinearExpression.
	extConstraint := self externalExpression cnLEQ: expr externalExpression.
	^ ConstraintCassowaryExpression new externalConstraintExpression: extConstraint! !

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 12:40'!
= x

	| expr extConstraint |
	expr := x asConstraintLinearExpression.
	extConstraint := self externalExpression cnEqual: expr externalExpression.
	^ ConstraintCassowaryExpression new externalConstraintExpression: extConstraint! !

!ConstraintLinearExpression methodsFor: 'comparing' stamp: 'mg 5/14/2014 12:42'!
>= x

	| expr extConstraint |
	expr := x asConstraintLinearExpression.
	extConstraint := self externalExpression cnGEQ: expr externalExpression.
	^ ConstraintCassowaryExpression new externalConstraintExpression: extConstraint! !

!ConstraintLinearExpression methodsFor: 'as yet unclassified' stamp: 'mg 5/14/2014 13:01'!
addExpressionToConstraint: aConstraint

	self error: 'This is only a linear expression, but it should be an equation.'! !

!ConstraintLinearExpression methodsFor: 'accessing' stamp: 'mg 4/23/2014 11:01'!
asConstraintLinearExpression

	^ self! !

!ConstraintLinearExpression methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:20'!
externalExpression

	^ externalExpression! !

!ConstraintLinearExpression methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:20'!
externalExpression: anObject

	externalExpression := anObject! !

Object subclass: #ConstraintGenericVariable
	instanceVariableNames: 'constraint originalValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintGenericVariable commentStamp: 'mg 4/16/2014 13:02' prior: 0!
A ConstraintGenericVariable represents all values that are used inside a constraint but does not have a concrete ConstraintVariable.

Instance Variables
	constraint:		The constraint is needed to invalidate and recreate the constraint, if this generic variable changes its value.
	originalValue:	The original object
!

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 15:56'!
asConstraintVariable

	^ self! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
constraint

	^ constraint! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
constraint: anObject

	constraint := anObject! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 14:42'!
isCassowaryVariable

	^ false! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/17/2014 10:49'!
isConstant
	"In general, constraint variables can be changed."
	^ false! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 5/13/2014 12:25'!
isZ3Variable

	^ false! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
originalValue

	^ originalValue! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
originalValue: anObject

	originalValue := anObject! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:26'!
suggestValue: aValue
	"This method adds an equality constraint for the new value. If all constraints are still solvable, the value is changed to aValue. Otherwise, the old value does not change and an exception is raised. Generic variables are not supposed to be changed. If so, all corresponding constraints should be recreated."! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/17/2014 10:06'!
value
	"Returns the value from the solver variable. A generic variable forwards all messages to the original object."
	^ originalValue! !

ConstraintGenericVariable subclass: #ConstraintVariable
	instanceVariableNames: 'externalVariable solver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintVariable commentStamp: 'mg 4/16/2014 13:07' prior: 0!
A ConstraintVariable is a concrete ConstraintVariable that does have a solver object for it.

Instance Variables
	externalVariable:	This is the solver object for the constraint variable.
!

ConstraintVariable subclass: #ConstraintCassowaryVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 4/24/2014 10:55'!
* x
	"This method should return a linear expression. x should be a number or constant. Otherwise, Cassowary raises an error."
	^ self asConstraintLinearExpression * x asConstantConstraintVariable value! !

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 4/23/2014 11:19'!
+ x
	"This method should return a linear expression"
	^ self asConstraintLinearExpression + x asConstraintLinearExpression! !

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 4/23/2014 14:07'!
- x
	"This method should return a linear expression"
	^ self asConstraintLinearExpression - x asConstraintLinearExpression! !

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 4/24/2014 12:44'!
/ x
	"This method should return a linear expression. x should be a number or constant. Otherwise, Cassowary raises an error."
	^ self asConstraintLinearExpression / x asConstantConstraintVariable value! !

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 5/5/2014 15:40'!
<= x

	^ self asConstraintLinearExpression <= x asConstraintLinearExpression! !

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 4/23/2014 13:53'!
= x

	^ self asConstraintLinearExpression = x asConstraintLinearExpression! !

!ConstraintCassowaryVariable methodsFor: 'comparing' stamp: 'mg 5/5/2014 15:45'!
>= x

	^ self asConstraintLinearExpression >= x asConstraintLinearExpression! !

!ConstraintCassowaryVariable methodsFor: 'accessing' stamp: 'mg 4/24/2014 10:56'!
asConstantConstraintVariable

	self error: 'A Cassowary variable is not constant.'.! !

!ConstraintCassowaryVariable methodsFor: 'accessing' stamp: 'mg 4/23/2014 11:00'!
asConstraintLinearExpression

	| expr |
	expr := ConstraintLinearExpression new.
	expr externalExpression: self externalVariable asLinearExpression.
	^ expr! !

!ConstraintCassowaryVariable methodsFor: 'initialize-release' stamp: 'mg 4/17/2014 13:37'!
initialize

	externalVariable := ClVariable newWith: self originalValue.! !

!ConstraintCassowaryVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 14:42'!
isCassowaryVariable
	
	^ true! !

!ConstraintCassowaryVariable methodsFor: 'accessing' stamp: 'mg 5/13/2014 12:34'!
suggestValue: aValue

	| extConstraint tmpConstraint |
	extConstraint := self externalVariable cnEqual: aValue.
	tmpConstraint := ConstraintCassowary new 
		addExternalConstraint: extConstraint;
		priority: (ConstraintPriority fromCassowaryStrength: extConstraint strength);
		solver: self solver.
	[tmpConstraint 	addConstraintsToSolver] 
		ifError: [ConstraintUnsatisfiableError new 
			signal: 'The value cannot be assigned because the constraints are unsatisfiable.'].
	tmpConstraint removeConstraintsFromSolver.! !

ConstraintVariable subclass: #ConstraintCollectionVariable
	instanceVariableNames: 'varName varValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintCollectionVariable methodsFor: 'as yet unclassified' stamp: 'mg 5/27/2014 15:49'!
allSatisfy: aBlock

	| collectionExpression newValue |
	collectionExpression := ConstraintCollectionExpression new.
	newValue := self value class new.
	self value do: [:each | | constraintExpression variable | 
						   variable := each asConstraintVariableForMethodName: 'item'.
						   newValue add: variable.
					 	   constraintExpression := aBlock value: variable.
						   collectionExpression expressions add: constraintExpression].
	self varValue: newValue.
	^ collectionExpression! !

!ConstraintCollectionVariable methodsFor: 'initialize-release' stamp: 'mg 5/27/2014 14:46'!
initialize

	varName := 'noName'.! !

!ConstraintCollectionVariable methodsFor: 'accessing' stamp: 'mg 5/27/2014 14:41'!
suggestValue: aCollection

! !

!ConstraintCollectionVariable methodsFor: 'accessing' stamp: 'mg 5/27/2014 15:48'!
value
	"A CollectionVariable has no externalVariable, so it stores the current value in varValue. varValue is a collection that contains constraint variables. The user might want to get the collection with the values, not the constraint variables."
	| valueCollection |
	valueCollection := varValue class new.
	varValue do: [:cv | valueCollection add: cv value].
	^ valueCollection! !

!ConstraintCollectionVariable methodsFor: 'accessing' stamp: 'mg 5/27/2014 14:39'!
varName

	^ varName! !

!ConstraintCollectionVariable methodsFor: 'accessing' stamp: 'mg 5/27/2014 14:39'!
varName: anObject

	varName := anObject! !

!ConstraintCollectionVariable methodsFor: 'private' stamp: 'mg 5/27/2014 14:44'!
varValue: anObject
"This method should only be called from a ConstraintSolver. Otherwise, the constraints may be broken."
	varValue := anObject! !

ConstraintVariable subclass: #ConstraintConstantVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintConstantVariable methodsFor: 'comparing' stamp: 'mg 4/23/2014 13:57'!
= x

	^ self asConstraintLinearExpression = x asConstraintLinearExpression! !

!ConstraintConstantVariable methodsFor: 'accessing' stamp: 'mg 4/17/2014 11:00'!
asConstantConstraintVariable

	^ self! !

!ConstraintConstantVariable methodsFor: 'accessing' stamp: 'mg 4/23/2014 13:55'!
asConstraintLinearExpression

	^ self value asConstraintLinearExpression! !

!ConstraintConstantVariable methodsFor: 'initialize-release' stamp: 'mg 4/17/2014 11:15'!
initialize
	"The value of a constant variable should never be nil, because it cannot be changed afterwards."

	originalValue := -1.! !

!ConstraintConstantVariable methodsFor: 'accessing' stamp: 'mg 4/17/2014 10:47'!
isConstant
	"Constant variables are read-only."
	^ true! !

!ConstraintConstantVariable methodsFor: 'accessing' stamp: 'mg 4/22/2014 11:38'!
suggestValue: aValue

	self error: 'The constraint variable is read-only.'.! !

!ConstraintVariable class methodsFor: 'instance creation' stamp: 'mg 5/5/2014 14:07'!
newCassowaryVariableFor: aNumber

	| cv extVar |
	cv := ConstraintCassowaryVariable new.
	extVar := ClVariable newWith: aNumber asFloat name: aNumber name.
	cv 
		originalValue: aNumber;
		externalVariable: extVar;
		solver: (Processor activeProcess environmentAt: #constraintObject) solver.
	cv solver addStay: cv.
	^ cv! !

!ConstraintVariable class methodsFor: 'instance creation' stamp: 'mg 5/27/2014 15:18'!
newCollectionVariableFor: aValue withName: aName

	| cv |
	cv := ConstraintCollectionVariable new.
	cv 
		originalValue: aValue;
		varValue: aValue;
		solver: (Processor activeProcess environmentAt: #constraintObject) solver;
		varName: aName.
	^ cv! !

!ConstraintVariable class methodsFor: 'instance creation' stamp: 'mg 4/17/2014 10:59'!
newConstantVariableFor: aNumber

	| cv extVar |
	cv := ConstraintConstantVariable new.
	cv originalValue: aNumber.
	"maybe the external variable is another one?"
	extVar := ClVariable newWith: aNumber asFloat name: aNumber name.
	cv externalVariable: extVar.
	^ cv! !

!ConstraintVariable class methodsFor: 'instance creation' stamp: 'mg 5/13/2014 13:53'!
newZ3VariableFor: aValue

	| cv |
	cv := ConstraintZ3Variable new.
	cv 
		originalValue: aValue;
		varValue: aValue;
		solver: (Processor activeProcess environmentAt: #constraintObject) solver.
	cv solver addVariable: cv.
	^ cv! !

!ConstraintVariable class methodsFor: 'instance creation' stamp: 'mg 5/13/2014 14:54'!
newZ3VariableFor: aValue withName: aName

	| cv |
	cv := ConstraintZ3Variable new.
	cv 
		originalValue: aValue;
		varValue: aValue;
		solver: (Processor activeProcess environmentAt: #constraintObject) solver;
		varName: aName.
	cv solver addVariable: cv.
	^ cv! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:06'!
asConstantConstraintVariable

	^ ConstraintConstantVariable new
			constraint: self constraint;
			originalValue: self originalValue;
			solver: self solver;
			externalVariable: self externalVariable! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:21'!
externalVariable

	^ externalVariable! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:21'!
externalVariable: anObject

	externalVariable := anObject! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:06'!
solver

	^ solver! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:06'!
solver: anObject

	solver := anObject! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 5/13/2014 10:38'!
suggestValue: aValue
	"This method adds an equality constraint for the new value. If all constraints are still solvable, the value is changed to aValue. Otherwise, the old value does not change and an exception is raised."
	self subclassResponsibility.! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/23/2014 10:14'!
value
	"Returns the value from the solver variable."
	^ externalVariable value! !

ConstraintVariable subclass: #ConstraintZ3Variable
	instanceVariableNames: 'varName varValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/13/2014 13:43'!
* x

	^ ConstraintBinaryExpression new
			operator: '*';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/13/2014 13:43'!
+ x

	^ ConstraintBinaryExpression new
			operator: '+';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/13/2014 13:43'!
- x

	^ ConstraintBinaryExpression new
			operator: '-';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/13/2014 13:43'!
/ x

	^ ConstraintBinaryExpression new
			operator: '/';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:47'!
< x

	^ ConstraintBinaryExpression new
			operator: '<';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:42'!
<= x

	^ ConstraintBinaryExpression new
			operator: '<=';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/14/2014 11:24'!
= x

	| binaryExpr |
	binaryExpr := ConstraintBinaryExpression new
		operator: '=';
		leftSide: self;
		rightSide: x.
	^ binaryExpr! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:47'!
> x

	^ ConstraintBinaryExpression new
			operator: '>';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 11:42'!
>= x

	^ ConstraintBinaryExpression new
			operator: '>=';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:07'!
cos

	^ (self + Float halfPi) sin! !

!ConstraintZ3Variable methodsFor: 'initialize-release' stamp: 'mg 5/13/2014 12:29'!
initialize

	varName := 'noName'.! !

!ConstraintZ3Variable methodsFor: 'accessing' stamp: 'mg 5/13/2014 12:26'!
isZ3Variable

	^ true! !

!ConstraintZ3Variable methodsFor: 'printing' stamp: 'mg 5/13/2014 10:48'!
print

	^ self varName! !

!ConstraintZ3Variable methodsFor: 'printing' stamp: 'mg 5/26/2014 15:39'!
printDeclaration

	| type |
	type := 'Real'.
	"self originalValue isInteger
		ifTrue: [type := 'Int']."
	(self originalValue isKindOf: Boolean)
		ifTrue: [type := 'Bool'].

	^ '(declare-fun ', self varName, ' () ', type, ')'! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 15:51'!
raisedTo: x

	^ ConstraintBinaryExpression new
			operator: '^';
			leftSide: self;
			rightSide: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 13:38'!
raisedToInteger: x

	^ self raisedTo: x! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 16:20'!
sin

	^ self 
		- ((self raisedTo: 3) / 6) 
		+ ((self raisedTo: 5) / 120)
		- ((self raisedTo: 7) / 5040) 
		+ ((self raisedTo: 9) / 362880)
		- ((self raisedTo: 11) / 39916800) 
		+ ((self raisedTo: 13) /  6227020800)
		- ((self raisedTo: 15) /  1307674368000) 
		+ ((self raisedTo: 17) /  355687428096000)! !

!ConstraintZ3Variable methodsFor: 'comparing' stamp: 'mg 5/26/2014 13:38'!
squared

	^ self raisedTo: 2! !

!ConstraintZ3Variable methodsFor: 'accessing' stamp: 'mg 5/26/2014 11:12'!
suggestValue: aValue
"This method adds an equality constraint for the new value. If all constraints are still solvable, the value is changed to aValue. Otherwise, the old value does not change and an exception is raised."
	| tmpExpr tmpConstraint |
	(self value = aValue)
		ifTrue: [^ self].	

	tmpExpr := ConstraintBinaryExpression new
		operator: '=';
		leftSide: self;
		rightSide: aValue.
	tmpConstraint := ConstraintZ3 new 
		addExpression: tmpExpr;
		solver: self solver.
	[tmpConstraint 	addConstraintsToSolver] 
		ifError: [tmpConstraint removeConstraintsFromSolver.
				ConstraintUnsatisfiableError new 
					signal: 'The value cannot be assigned because the constraints are unsatisfiable.'].
	tmpConstraint removeConstraintsFromSolver.! !

!ConstraintZ3Variable methodsFor: 'accessing' stamp: 'mg 5/13/2014 10:57'!
value
	"A Z3Variable has no externalVariable, so it stores the current value in varValue."
	^ varValue! !

!ConstraintZ3Variable methodsFor: 'accessing' stamp: 'mg 5/13/2014 10:40'!
varName

	^ varName! !

!ConstraintZ3Variable methodsFor: 'accessing' stamp: 'mg 5/13/2014 10:40'!
varName: anObject

	varName := anObject! !

!ConstraintZ3Variable methodsFor: 'private' stamp: 'mg 5/13/2014 11:00'!
varValue: anObject
"This method should only be called from a ConstraintZ3Solver. Otherwise, the constraints may be broken."
	varValue := anObject! !

Object subclass: #ConstraintPriority
	instanceVariableNames: 'name val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintPriority commentStamp: 'mg 4/16/2014 12:05' prior: 0!
A ConstraintPriority is a named priority object. It represents the priority of a constraint.

Instance Variables
	name:	symbolic name for a priority
	val:		a number for the priority to simplify comparisons between priorities 

!

!ConstraintPriority class methodsFor: 'instance creation' stamp: 'mg 4/16/2014 15:34'!
fromCassowaryStrength: aClStrength

	aClStrength isRequired ifTrue: [^ ConstraintPriority required].
	aClStrength isStrong ifTrue: [^ ConstraintPriority strong].
	aClStrength isMedium ifTrue: [^ ConstraintPriority medium].
	aClStrength isWeak ifTrue: [^ ConstraintPriority weak].! !

!ConstraintPriority class methodsFor: 'instance creation' stamp: 'mg 4/16/2014 11:56'!
medium

	^ self new 
		name: 'medium';
		val: 2! !

!ConstraintPriority class methodsFor: 'instance creation' stamp: 'mg 4/16/2014 11:55'!
required

	^ self new 
		name: 'required';
		val: 0! !

!ConstraintPriority class methodsFor: 'instance creation' stamp: 'mg 4/16/2014 11:55'!
strong

	^ self new 
		name: 'strong';
		val: 1! !

!ConstraintPriority class methodsFor: 'instance creation' stamp: 'mg 4/16/2014 11:56'!
weak

	^ self new 
		name: 'weak';
		val: 3! !

!ConstraintPriority methodsFor: 'comparing' stamp: 'mg 4/16/2014 12:02'!
< aConstraintPriority

	^ self val < aConstraintPriority val! !

!ConstraintPriority methodsFor: 'comparing' stamp: 'mg 4/16/2014 11:58'!
<= aConstraintPriority

	^ self val <= aConstraintPriority val! !

!ConstraintPriority methodsFor: 'comparing' stamp: 'mg 5/5/2014 15:05'!
= aConstraintPriority

	^ self val = aConstraintPriority val! !

!ConstraintPriority methodsFor: 'as yet unclassified' stamp: 'mg 5/5/2014 15:23'!
asCassowaryStrength

	val = 0 ifTrue: [^ ClStrength required].
	val = 1 ifTrue: [^ ClStrength strong].
	val = 2 ifTrue: [^ ClStrength medium].
	val = 3 ifTrue: [^ ClStrength weak].! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:57'!
name
		
	^ name! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:56'!
name: anObject

	name := anObject! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:56'!
val

	^ val! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:56'!
val: anObject

	val := anObject! !

Object subclass: #ConstraintSolver
	instanceVariableNames: 'constraints stayConstraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintSolver commentStamp: 'mg 5/12/2014 14:26' prior: 0!
ConstraintSolver is the abstract class for all constraint solver.

Instance Variables
	constraints:		<Object>
	stayConstraints:	This collection consists of ConstraintVariables, that have a weak stay constraint.
!

ConstraintSolver subclass: #ConstraintCassowarySolver
	instanceVariableNames: 'externalSolver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

ConstraintCassowarySolver class
	instanceVariableNames: 'CassowarySolver ExternalCassowarySolver'!

!ConstraintCassowarySolver commentStamp: 'mg 5/12/2014 14:27' prior: 0!
A ConstraintCassowarySolver manage all constraints, that can be solved with Cassowary.

Instance Variables
	externalSolver:		<Object>!

ConstraintCassowarySolver class
	instanceVariableNames: 'CassowarySolver ExternalCassowarySolver'!

!ConstraintCassowarySolver class methodsFor: 'instance creation' stamp: 'mg 5/12/2014 14:20'!
cassowarySolver

	CassowarySolver ifNil: [CassowarySolver := self basicNew initialize].
	ExternalCassowarySolver ifNil: [ExternalCassowarySolver := ClSimplexSolver new autoSolve: false].
	CassowarySolver externalSolver: ExternalCassowarySolver.
	^ CassowarySolver! !

!ConstraintCassowarySolver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 13:10'!
constraintClass

	^ ConstraintCassowary! !

!ConstraintCassowarySolver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 10:55'!
constraintVariableFor: aValue

	aValue isNumber
		ifTrue: [^ ConstraintVariable newCassowaryVariableFor: aValue].
	^ ConstraintGenericVariable new originalValue: aValue! !

!ConstraintCassowarySolver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 14:56'!
constraintVariableFor: aValue withName: aName

	^ self constraintVariableFor: aValue! !

!ConstraintCassowarySolver class methodsFor: 'instance creation' stamp: 'mg 5/12/2014 14:20'!
newCassowarySolver

	| solver |
	solver := self new.
	solver externalSolver: (ClSimplexSolver new autoSolve: false).
	^ solver! !

!ConstraintCassowarySolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:20'!
addConstraint: aConstraint

	(self constraints includes: aConstraint)
		ifTrue: [Transcript show: 'WARNING - The constraint is already enabled.'; cr. ^ self].

	[aConstraint externalConstraints 
		do: [:extConstraint | self externalSolver addConstraint: extConstraint]] 
	ifError: [ConstraintUnsatisfiableError new signal: 
			'The value cannot be assigned because the constraints are unsatisfiable.'].
	self constraints add: aConstraint.
	self solve.! !

!ConstraintCassowarySolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:20'!
addStay: aConstraintVariable

	self stayConstraints add: aConstraintVariable.
	self externalSolver addStay: aConstraintVariable externalVariable.! !

!ConstraintCassowarySolver methodsFor: 'accessing' stamp: 'mg 5/12/2014 14:20'!
externalSolver

	^ externalSolver! !

!ConstraintCassowarySolver methodsFor: 'accessing' stamp: 'mg 5/12/2014 14:20'!
externalSolver: anObject

	externalSolver := anObject! !

!ConstraintCassowarySolver methodsFor: 'initialize-release' stamp: 'mg 5/12/2014 14:29'!
initialize

	super initialize.
	externalSolver := ClSimplexSolver new.! !

!ConstraintCassowarySolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:30'!
removeAllConstraints

	super removeAllConstraints.
	self externalSolver initialize.
	self externalSolver autoSolve: false.! !

!ConstraintCassowarySolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:20'!
removeConstraint: aConstraint

	(self constraints includes: aConstraint)
		ifFalse: [Transcript show: 'WARNING - The constraint cannot be disabled, because it is not enabled.'; cr. ^ self].

	self constraints remove: aConstraint.
	aConstraint externalConstraints 
		do: [:extConstraint | self externalSolver removeConstraint: extConstraint].! !

!ConstraintCassowarySolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:20'!
solve
	"This method triggers the external solver to solve the constraints. It may raise an exception, if the constraints are unsatisfiable."
	self externalSolver solve.! !

!ConstraintSolver class methodsFor: 'instance creation' stamp: 'mg 5/12/2014 14:23'!
cassowarySolver

	^ ConstraintCassowarySolver cassowarySolver! !

!ConstraintSolver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 13:10'!
constraintClass

	self subclassResponsibility.! !

!ConstraintSolver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 10:53'!
constraintVariableFor: aValue

	^ ConstraintGenericVariable new originalValue: aValue! !

!ConstraintSolver class methodsFor: 'instance creation' stamp: 'mg 5/12/2014 14:24'!
newCassowarySolver

	^ ConstraintCassowarySolver newCassowarySolver! !

!ConstraintSolver class methodsFor: 'instance creation' stamp: 'mg 5/12/2014 14:38'!
newZ3Solver

	^ ConstraintZ3Solver newZ3Solver! !

!ConstraintSolver methodsFor: 'manipulating' stamp: 'mg 5/26/2014 11:25'!
addConstraint: aConstraint

	(self constraints includes: aConstraint)
		ifTrue: [Transcript show: 'WARNING - The constraint is already enabled.'; cr. ^ self].
	self constraints add: aConstraint.
	[self solve] ifError: [self constraints remove: aConstraint. ConstraintUnsatisfiableError new signal].! !

!ConstraintSolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:33'!
addStay: aConstraintVariable

	self stayConstraints add: aConstraintVariable.! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:11'!
constraints

	^ constraints! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:11'!
constraints: anObject

	constraints := anObject! !

!ConstraintSolver methodsFor: 'initialize-release' stamp: 'mg 5/12/2014 14:29'!
initialize

	constraints := OrderedCollection new.
	stayConstraints := OrderedCollection new.! !

!ConstraintSolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:30'!
removeAllConstraints

	self constraints removeAll.
	self stayConstraints removeAll.! !

!ConstraintSolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:41'!
removeConstraint: aConstraint

	(self constraints includes: aConstraint)
		ifFalse: [Transcript show: 'WARNING - The constraint cannot be disabled, because it is not enabled.'; cr. ^ self].

	self constraints remove: aConstraint.
! !

!ConstraintSolver methodsFor: 'manipulating' stamp: 'mg 5/12/2014 14:28'!
solve
	"This method should satisfy all constraints."
	self subclassResponsibility.! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/23/2014 10:28'!
stayConstraints

	^ stayConstraints! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/23/2014 10:28'!
stayConstraints: anObject

	stayConstraints := anObject! !

ConstraintSolver subclass: #ConstraintZ3Solver
	instanceVariableNames: 'variables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintZ3Solver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 13:10'!
constraintClass

	^ ConstraintZ3! !

!ConstraintZ3Solver class methodsFor: 'as yet unclassified' stamp: 'mg 5/13/2014 10:55'!
constraintVariableFor: aValue

	(aValue isNumber or: [aValue isKindOf: Boolean])
		ifTrue: [^ ConstraintVariable newZ3VariableFor: aValue].
	^ ConstraintGenericVariable new originalValue: aValue! !

!ConstraintZ3Solver class methodsFor: 'as yet unclassified' stamp: 'mg 5/27/2014 14:38'!
constraintVariableFor: aValue withName: aName

	(aValue isNumber or: [aValue isKindOf: Boolean])
		ifTrue: [^ ConstraintVariable newZ3VariableFor: aValue withName: aName].
	(aValue isCollection)
		ifTrue: [^ ConstraintVariable newCollectionVariableFor: aValue withName: aName].
	^ ConstraintGenericVariable new originalValue: aValue! !

!ConstraintZ3Solver class methodsFor: 'instance creation' stamp: 'mg 5/12/2014 14:39'!
newZ3Solver

	^ self new! !

!ConstraintZ3Solver methodsFor: 'accessing' stamp: 'mg 5/13/2014 15:09'!
addVariable: aConstraintVariable

	| varNames varsWithSameName |
	varsWithSameName := self variables select: [:var | var varName beginsWith: aConstraintVariable varName].
	varNames := varsWithSameName collect: [:var | var varName].
	varNames sort.
	varNames ifNotEmpty: [aConstraintVariable varName: 
		aConstraintVariable varName, (varNames last splitInteger last + 1) asString].	
	self variables add: aConstraintVariable.! !

!ConstraintZ3Solver methodsFor: 'solving' stamp: 'mg 5/12/2014 14:48'!
binaryPath

	^ 'c:\studium\masterarbeit\z3-4.3.0-x64\bin\z3.exe'! !

!ConstraintZ3Solver methodsFor: 'solving' stamp: 'mg 5/13/2014 14:04'!
buildProgram
"This method returns the string that is the Z3 program (SMT2 format)."
	| program |
	program := '(set-option :pp-decimal true)', Character cr,
				'(set-option :produce-models true)', Character cr.
	self variables do: [:v | program := program, v printDeclaration, Character cr].
	self constraints do: [:c | program := program, c print, Character cr].
	program := program, 
				'(check-sat)', Character cr,
				'(get-model)'.
	^ program! !

!ConstraintZ3Solver methodsFor: 'solving' stamp: 'mg 5/12/2014 15:03'!
executeProgram: aString
"This method executes the program by calling the external binary of Z3. The path is defined in self>>binaryPath."
	| bin out parms proc |
	out := ''.
	bin := self binaryPath.
	parms := ' -nw -smt2 -T:20 '.
	OSProcess isWindows
		ifFalse: [Transcript show: 'WARNING - The execution is only possible under Windows'; cr]
		ifTrue: [	(StandardFileStream forceNewFileNamed: 'tmp.smt2') nextPutAll: aString; close.
			proc := ExternalWindowsOSProcess command: 'cmd /c ', bin, parms, ' tmp.smt2 > out.z3'.
			[proc update: #runState. proc isRunning] whileTrue: [(Delay forMilliseconds: 50) wait].
			out := (StandardFileStream readOnlyFileNamed: 'out.z3') upToEnd].
	^ out! !

!ConstraintZ3Solver methodsFor: 'initialize-release' stamp: 'mg 5/12/2014 16:25'!
initialize

	super initialize.
	variables := OrderedCollection new.! !

!ConstraintZ3Solver methodsFor: 'solving' stamp: 'mg 5/26/2014 15:43'!
parseResult: aString
"This method parses the result string and returns a dictionary with the variable names and values."
	| varName flag variableDict |
	(aString beginsWith: 'sat')
		ifFalse: [ConstraintUnsatisfiableError new signal].

	variableDict := Dictionary new.
	flag := false.
	varName := ''.
	aString linesDo: [:line | | strippedLine | 
		strippedLine := line withoutLeadingBlanks.
		flag ifTrue: [ | value |
					flag := false.
					value := (strippedLine select: [:c | c isDigit or: [c = '-' asCharacter] or: [c = '.' asCharacter]]) asNumber.
					variableDict at: varName put: value].
		(strippedLine beginsWith: '(define-fun ')
			ifTrue: [flag := true. 
					varName := strippedLine substrings second]].

	^ variableDict! !

!ConstraintZ3Solver methodsFor: 'solving' stamp: 'mg 5/13/2014 11:01'!
setConstraintVariableValuesFrom: aDict
"This method should set the constraint variable values."

	self variables do: [:var | var varValue: (aDict at: var varName)].! !

!ConstraintZ3Solver methodsFor: 'manipulating' stamp: 'mg 5/13/2014 14:46'!
solve
"This method builds the Z3 program, executes the binary and parses the result."
	| program result variableValueDict |
	program := self buildProgram.
	result := self executeProgram: program.
	variableValueDict := self parseResult: result.
	self setConstraintVariableValuesFrom: variableValueDict.
	Transcript show: variableValueDict.
	! !

!ConstraintZ3Solver methodsFor: 'accessing' stamp: 'mg 5/12/2014 16:21'!
variables

	^ variables! !

Object subclass: #ExampleClass
	instanceVariableNames: 'a b collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ExampleClass methodsFor: 'comparing' stamp: 'tfel 5/8/2014 16:45'!
= another

	^ self class = another class
		and: [self a = another a
				and: [self b = another b]]! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:42'!
a

	^ a! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:42'!
a: anObject

	a := anObject! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:42'!
b

	^ b! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 5/5/2014 14:42'!
b: anObject

	b := anObject! !

!ExampleClass methodsFor: 'initialize-release' stamp: 'mg 5/26/2014 17:37'!
initialize

	a := 1.
	b := 2.
	collection := OrderedCollection new.! !

!Object methodsFor: '*Constraints' stamp: 'mg 4/17/2014 11:02'!
asConstantConstraintVariable

	self error: 'This object cannot be converted to a constant constraint variable because it has no external variable.'.! !

!Object methodsFor: '*Constraints' stamp: 'mg 4/16/2014 13:38'!
asConstraintVariable

	^ ConstraintGenericVariable new originalValue: self! !

!Object methodsFor: '*Constraints' stamp: 'mg 5/26/2014 17:43'!
asConstraintVariableForMethodName: aName

	^ (Processor activeProcess environmentAt: #constraintObject) solver class constraintVariableFor: self withName: aName! !

!Object methodsFor: '*Constraints' stamp: 'mg 5/14/2014 10:58'!
isBinaryExpression

	^ false! !

!Object methodsFor: '*Constraints' stamp: 'mg 4/30/2014 15:40'!
isConstraint

	^ false! !

!Object methodsFor: '*Constraints' stamp: 'mg 5/14/2014 12:55'!
isConstraintExpression

	^ false! !

Object subclass: #TestUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!TestUtilities class methodsFor: 'solving' stamp: 'mg 5/14/2014 13:05'!
solveConstraintExpression: aConstraintExpression

	| constraint |
	constraint := ConstraintCassowary new
		priority: ConstraintPriority required;
		solver: ConstraintSolver cassowarySolver;
		yourself.
	aConstraintExpression addExpressionToConstraint: constraint.
	constraint enable.! !

MwBlockMethodWrapper subclass: #ConstraintMethodWrapperForGetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintMethodWrapperForGetter methodsFor: 'evaluating' stamp: 'mg 4/22/2014 14:27'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| returnValue |
	returnValue := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	^ returnValue value! !

MwBlockMethodWrapper subclass: #ConstraintMethodWrapperForSetter
	instanceVariableNames: 'getMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintMethodWrapperForSetter methodsFor: 'accessing' stamp: 'mg 4/22/2014 14:34'!
getMethod

	^ getMethod! !

!ConstraintMethodWrapperForSetter methodsFor: 'accessing' stamp: 'mg 4/22/2014 14:34'!
getMethod: anObject

	getMethod := anObject! !

!ConstraintMethodWrapperForSetter methodsFor: 'evaluating' stamp: 'mg 4/22/2014 15:17'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| constraintVariable |
	constraintVariable := self getMethod valueWithReceiver: anObject arguments: Array new.
	constraintVariable suggestValue: anArrayOfObjects first.! !

Error subclass: #ConstraintUnsatisfiableError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 5/13/2014 13:11'!
alwaysSolveWith: aConstraintSolver
	"This method constructs constraints for all solvable constraints inside this blockClosure. It uses the given solver object."
	| newProcess constraint |
	newProcess := self newTerminatingProcess.
	constraint := aConstraintSolver class constraintClass new
					constraintBlock: self;
					priority: ConstraintPriority required;
					solver: aConstraintSolver;
					yourself.
	Processor activeProcess environmentAt: #constraintObject put: constraint.
	[#ccm withLayerDo: [[newProcess step] doWhileFalse: [newProcess suspendedContext isNil]]]
		ensure: [Processor activeProcess environmentRemoveKey: #constraintObject].
	newProcess terminate.
	constraint enable.
	^ constraint! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 5/5/2014 14:01'!
alwaysTrue
	"This method constructs constraints for all solvable constraints inside this blockClosure."
	^ self alwaysSolveWith: ConstraintSolver cassowarySolver! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 5/14/2014 10:47'!
newTerminatingProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self terminateProcess: self value.] asContext
		priority: Processor activePriority! !

!ClStrength methodsFor: '*Constraints' stamp: 'mg 4/16/2014 15:32'!
isMedium

	^ self == MediumStrength! !

!ClStrength methodsFor: '*Constraints' stamp: 'mg 4/16/2014 15:32'!
isStrong

	^ self == StrongStrength! !

!ClStrength methodsFor: '*Constraints' stamp: 'mg 4/16/2014 15:32'!
isWeak

	^ self == WeakStrength! !

!Number methodsFor: '*Constraints' stamp: 'mg 4/17/2014 10:57'!
asConstantConstraintVariable

	^ ConstraintVariable newConstantVariableFor: self! !

!Number methodsFor: '*Constraints' stamp: 'mg 4/23/2014 11:05'!
asConstraintLinearExpression

	^ ConstraintLinearExpression new
		externalExpression: self asLinearExpression! !

!Number methodsFor: '*Constraints' stamp: 'mg 5/13/2014 12:18'!
asConstraintVariable

	^ (Processor activeProcess environmentAt: #constraintObject) solver class constraintVariableFor: self! !

!Number methodsFor: '*Constraints' stamp: 'mg 5/13/2014 14:57'!
asConstraintVariableForMethodName: aName

	^ (Processor activeProcess environmentAt: #constraintObject) solver class constraintVariableFor: self withName: aName! !

!Number methodsFor: '*Constraints' stamp: 'mg 5/13/2014 13:51'!
print

	^ self value! !

TestCase subclass: #ConstraintsCollectionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ConstraintsCollectionTests methodsFor: 'testing' stamp: 'mg 5/27/2014 15:36'!
testAllSatisfy

	| ex solver |
	ex := ExampleClass new.
	ex collection add: 1; add: 2; add: 0.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex collection allSatisfy: [:each | each >= 3]] alwaysSolveWith: solver] raise: Error.

	self should: [ex collection first >= 3].
	self should: [ex collection second >= 3].
	self should: [ex collection third >= 3].! !

!ConstraintsCollectionTests methodsFor: 'testing' stamp: 'mg 5/27/2014 15:34'!
testAllSatisfyObjects

	| ex solver constraint constraintExpr |
	ex := ExampleClass new.
	ex collection add: 1; add: 2.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [constraint := [ex collection allSatisfy: [:each | each >= 3]] alwaysSolveWith: solver] raise: Error.
	self should: [constraint expressions size = 1].
	constraintExpr := constraint expressions first.
	self should: [constraintExpr isConstraintCollectionExpression].
	self should: [constraintExpr expressions size = 2].! !

TestCase subclass: #ConstraintsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ConstraintsTests methodsFor: 'running' stamp: 'mg 4/23/2014 10:33'!
setUp

	| wrappers |
	ConstraintSolver cassowarySolver removeAllConstraints.

	[wrappers := ExampleClass methodDict values select: [:method | method isMwMethodWrapper]. 
	wrappers do: [:w | w uninstall]] doWhileFalse: [wrappers isEmpty].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/23/2014 09:59'!
testChangeOfSingleVariableValue

	| ex |
	ex := ExampleClass new.
	self shouldnt: [[ex a = 42] alwaysTrue.] raise: Error.
	self should: [ex a = 42].

	self should: [ex a: 23] raise: ConstraintUnsatisfiableError.
	self should: [ex a = 42].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'tfel 5/8/2014 16:44'!
testComplexConjunctionWithAnd

	| pt1 pt2 |
	pt1 := ExampleClass new.
	pt1 a: 20; b: 20.
	pt2 := ExampleClass new.
	pt2 a: 10; b: 10.

      self shouldnt: [[pt1 a = pt2 a and: [pt1 b = pt2 b]] alwaysTrue] raise: Error.
	self should: [pt1 a = pt2 a].
	self should: [pt1 b = pt2 b].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'tfel 5/8/2014 16:45'!
testComplexConjunctionWithAnd2

	| pt1 pt2 |
	pt1 := ExampleClass new.
	pt1 a: 20; b: 20.
	pt2 := ExampleClass new.
	pt2 a: 10; b: 10.

      self shouldnt: [[pt1 = pt2] alwaysTrue] raise: Error.
	self should: [pt1 a = pt2 a].
	self should: [pt1 b = pt2 b].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/5/2014 16:32'!
testComplexInequalityConstraints

	| ex ex2 constraint |
	ex := ExampleClass new.
	ex a: 15.
	ex b: 15.
	ex2 := ExampleClass new.
	ex2 a: 5.
	ex2 b: 5.

	self shouldnt: [[ex a <= 10] alwaysTrue] raise: Error.
	self shouldnt: [[ex b >= 20] alwaysTrue] raise: Error.
	self should: [[ex a = ex b] alwaysTrue] raise: ConstraintUnsatisfiableError.

	self shouldnt: [[ex a <= ex2 a] alwaysTrue] raise: Error.
	self shouldnt: [constraint := [ex2 a >= 20] alwaysTrue] raise: Error.
	constraint disable.
	self shouldnt: [constraint := [ex2 a <= 5] alwaysTrue] raise: Error.
	constraint disable.

	self shouldnt: [[ex b <= ex2 a] alwaysTrue] raise: Error.
	self should: [[ex2 a <= 10] alwaysTrue] raise: ConstraintUnsatisfiableError.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/26/2014 11:59'!
testComplexInequalityConstraintsWithExpressions

	| ex ex2 solver |
	ex := ExampleClass new.
	ex a: 15.
	ex b: 15.
	ex2 := ExampleClass new.
	ex2 a: 5.
	ex2 b: 5.
	solver := ConstraintSolver newCassowarySolver.

	self shouldnt: [[ex a + ex b <= 10] alwaysSolveWith: solver] raise: Error.
	self should: [ex a + ex b <= 10].

	self shouldnt: [[ex2 a + ex2 b >= 10] alwaysSolveWith: solver] raise: Error.
	self should: [ex2 a + ex2 b >= 10].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:45'!
testComplexLinearExpression

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))] alwaysTrue] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].

	self shouldnt: [ex a: 1] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].
	self should: [ex a = 1].

	self shouldnt: [ex2 b: 2] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].
	self should: [ex2 b = 2].

	self shouldnt: [ex3 a: 3] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].
	self should: [ex3 a = 3].

	self shouldnt: [ex2 a: 4] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].
	self should: [ex2 a = 4].

	self shouldnt: [ex b: 5] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].
	self should: [ex b = 5].

	self shouldnt: [ex3 b: 6] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].
	self should: [ex3 b = 6].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:45'!
testComplexLinearExpressionWithDivision

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) / 3.0 = (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))] alwaysTrue] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].

	self shouldnt: [ex a: 1] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex a clApprox: 1].

	self shouldnt: [ex2 b: 2] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex2 b clApprox: 2].

	self shouldnt: [ex2 a: 4] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex2 a clApprox: 4].

	self shouldnt: [ex b: 5] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex b clApprox: 5].

	self shouldnt: [ex3 a: 6] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex3 a clApprox: 6].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:45'!
testComplexLinearExpressionWithMultiplication

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) * 3 = (ex2 a * 2 + (ex b - ex3 a * (-4)))] alwaysTrue] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].

	self shouldnt: [ex a: 1] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex a clApprox: 1].

	self shouldnt: [ex2 b: 2] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex2 b clApprox: 2].

	self shouldnt: [ex2 a: 4] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex2 a clApprox: 4].

	self shouldnt: [ex b: 5] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex b clApprox: 5].

	self shouldnt: [ex3 a: 6] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex3 a clApprox: 6].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:46'!
testConjunction

	| ex |
	ex := ExampleClass new.

	self shouldnt: [[ex a = 2 & (ex b = 2)] alwaysTrue] raise: Error.
	self should: [ex a = 2].
	self should: [ex b = 2].

	self should: [ex a: 3] raise: ConstraintUnsatisfiableError.
	self should: [ex b: 3] raise: ConstraintUnsatisfiableError.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 14:28'!
testConjunctionChain

	| ex ex2 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	solver := ConstraintSolver newCassowarySolver.

	self shouldnt: [[ex a = 1 & (ex b = 2) & (ex2 a = 3) & (ex2 b = 4)] alwaysSolveWith: solver] raise: Error.
	self should: [ex a = 1].
	self should: [ex b = 2].
	self should: [ex2 a = 3].
	self should: [ex2 b = 4].

	self should: [solver constraints size = 1].
	self should: [solver constraints first externalConstraints size = 4].

	self should: [ex a: 21] raise: ConstraintUnsatisfiableError.
	self should: [ex b: 21] raise: ConstraintUnsatisfiableError.
	self should: [ex2 a: 21] raise: ConstraintUnsatisfiableError.
	self should: [ex2 b: 21] raise: ConstraintUnsatisfiableError.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/30/2014 16:57'!
testConjunctionError

	| ex |
	ex := ExampleClass new.
	ex a: 1.
	ex b: 1.

	self shouldnt: [[ex a = 3] alwaysTrue] raise: Error.
	self should: [ex a = 3].
	self should: [ex b = 1].

	self should: [[(ex b = 2) & (ex a = 2)] alwaysTrue] raise: ConstraintUnsatisfiableError.
	self should: [ex a = 3].
	self should: [ex b = 1].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'tfel 5/8/2014 15:11'!
testConjunctionWithAnd

	| ex |
	ex := ExampleClass new.

      self shouldnt: [[ex a = 3 and: [ex b = 3]] alwaysTrue] raise: Error.
	self should: [ex a = 3].
	self should: [ex b = 3].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/28/2014 14:33'!
testConstrainedInstances

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 17.
	ex2 := ExampleClass new.
	ex2 a: 23.

	self shouldnt: [[ex a = 42] alwaysTrue.] raise: Error.
	self should: [ex a = 42].
	self should: [ex2 a = 23].

	self should: [ex a: 3] raise: ConstraintUnsatisfiableError.
	self shouldnt: [ex2 a: 3] raise: Error.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 14:21'!
testConstraintBlockWithoutVariables

	self shouldnt: [[1 = 1] alwaysTrue] raise: Error.
	self should: [[1 = 2] alwaysTrue] raise: Error.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/13/2014 12:34'!
testConstraintObject

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	ex3 := ExampleClass new.

	self should: [[(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))] alwaysTrue class == ConstraintCassowary].
	self should: [[(ex a - ex2 b) * 3 = (ex2 a * 2 + (ex b - ex3 a * (-4)))] alwaysTrue class == ConstraintCassowary].
	self should: [[(ex a - ex2 b) / 3.0 = (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))] alwaysTrue class == ConstraintCassowary].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/13/2014 12:34'!
testConstraintObjectForConjunction

	| ex ex2 |
	ex := ExampleClass new.
	ex2 := ExampleClass new.

	self should: [[ex a = 2 & (ex b = 4)] alwaysTrue class == ConstraintCassowary].
	self should: [[(ex a = 2 & (ex2 b = 4)) & (ex2 a = 8)] alwaysTrue class == ConstraintCassowary].
	self should: [[(ex2 a = 8) & (ex a = 2 & (ex2 b = 4))] alwaysTrue class == ConstraintCassowary].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/5/2014 11:30'!
testConstraintObjectInterface

	| ex constraint |
	ex := ExampleClass new.

	constraint := [ex a = 2] alwaysTrue.
	self should: [constraint isConstraint].

	self shouldnt: [constraint enable] raise: Error.	"Should print a Warning, because it is already enabled."
	self should: [ex a: 3] raise: ConstraintUnsatisfiableError.

	self shouldnt: [constraint disable] raise: Error.
	self shouldnt: [ex a: 4] raise: Error.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/5/2014 14:18'!
testConstraintsWithGivenSolverObject

	| solver ex |
	ex := ExampleClass new.
	solver := ConstraintSolver newCassowarySolver.

	self shouldnt: [[ex a = 42] alwaysSolveWith: solver] raise: Error.
	self should: [ex a = 42].
	self should: [(ex instVarAt: 1) solver == solver].
	self should: [ex a: 21] raise: ConstraintUnsatisfiableError.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:46'!
testEqualityOfTwoVariables

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 23.
	ex2 := ExampleClass new.
	ex2 a: 17.

	self shouldnt: [[ex a = ex2 a] alwaysTrue] raise: Error.
	self should: [ex a = ex2 a].

	self shouldnt: [ex2 a: 42] raise: Error.
	self should: [ex a = ex2 a].
	self should: [ex2 a = 42].

	self shouldnt: [ex a: 9] raise: Error.
	self should: [ex a = ex2 a].
	self should: [ex a = 9].

	self shouldnt: [ex2 a: 21] raise: Error.
	self should: [ex a = ex2 a].
	self should: [ex2 a = 21].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/5/2014 15:44'!
testInequality

	| ex |
	ex := ExampleClass new.
	ex a: 15.
	ex b: 15.

	self shouldnt: [[ex a <= 10] alwaysTrue] raise: Error.
	self should: [ex a <= 10].
	self should: [ex a = 10].

	self shouldnt: [ex a: 7] raise: Error.
	self should: [ex a = 7].

	self should: [ex a: 17] raise: ConstraintUnsatisfiableError.
	self should: [ex a = 7].

	self shouldnt: [[ex b >= 20] alwaysTrue] raise: Error.
	self should: [ex b >= 20].
	self should: [ex b = 20].

	self shouldnt: [ex b: 27] raise: Error.
	self should: [ex b = 27].

	self should: [ex b: 17] raise: ConstraintUnsatisfiableError.
	self should: [ex b = 27].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/23/2014 17:05'!
testInstancevariableClass

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) + ex3 a = (ex b + ex3 b)] alwaysTrue] raise: Error.

	self should: [(ex instVarNamed: 'a') class == ConstraintCassowaryVariable].
	self should: [(ex instVarNamed: 'b') class == ConstraintCassowaryVariable].

	self shouldnt: [(ex2 instVarNamed: 'a') class == ConstraintCassowaryVariable].
	self should: [(ex2 instVarNamed: 'b') class == ConstraintCassowaryVariable].

	self should: [(ex3 instVarNamed: 'a') class == ConstraintCassowaryVariable].
	self should: [(ex3 instVarNamed: 'b') class == ConstraintCassowaryVariable].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:46'!
testLinearExpressionAddition

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 23.
	ex2 := ExampleClass new.
	ex2 a: 17.

	self shouldnt: [[ex a + ex2 a = 42] alwaysTrue] raise: Error.
	self should: [ex a + ex2 a = 42].

	self shouldnt: [ex a: 13] raise: Error.
	self should: [ex a + ex2 a = 42].
	self should: [ex a = 13].

	self shouldnt: [ex2 a: 17] raise: Error.
	self should: [ex a + ex2 a = 42].
	self should: [ex2 a = 17].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:47'!
testLinearExpressionDivision

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 23.
	ex2 := ExampleClass new.
	ex2 a: 17.

	self shouldnt: [[ex a / 3.0 = 42] alwaysTrue] raise: Error.
	self should: [ex a / 3.0 = 42].

	self should: [ex a: 13] raise: ConstraintUnsatisfiableError.
	self should: [ex a / 3.0 = 42].
	self should: [ex a = 126].

	self shouldnt: [ex a: 126] raise: Error.
	self should: [ex a / 3.0 = 42].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:47'!
testLinearExpressionMultiplication

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 23.
	ex2 := ExampleClass new.
	ex2 a: 17.

	self shouldnt: [[ex a * 3 = 42] alwaysTrue] raise: Error.
	self should: [ex a * 3 = 42].

	self should: [ex a: 13] raise: ConstraintUnsatisfiableError.
	self should: [ex a * 3 = 42].
	self should: [ex a = 14].

	self shouldnt: [ex a: 14] raise: Error.
	self should: [ex a * 3 = 42].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:47'!
testLinearExpressionSubtraction

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 23.
	ex2 := ExampleClass new.
	ex2 a: 17.

	self shouldnt: [[ex a - ex2 a = 42] alwaysTrue] raise: Error.
	self should: [ex a - ex2 a = 42].

	self shouldnt: [ex a: 13] raise: Error.
	self should: [ex a - ex2 a = 42].
	self should: [ex a = 13].

	self shouldnt: [ex2 a: 17] raise: Error.
	self should: [ex a - ex2 a = 42].
	self should: [ex2 a = 17].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/28/2014 15:25'!
testMethodWrapper

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))] alwaysTrue] raise: Error.
	self should: [(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))].

	self should: [(ex class methodDict at: #a) class == ConstraintMethodWrapperForGetter].
	self should: [(ex class methodDict at: #b) class == ConstraintMethodWrapperForGetter].

	self should: [(ex class methodDict at: #a:) class == ConstraintMethodWrapperForSetter].
	self should: [(ex class methodDict at: #b:) class == ConstraintMethodWrapperForSetter].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/5/2014 14:39'!
testMultipleSolvers

	| ex solver solver2 |
	ex := ExampleClass new.
	solver := ConstraintSolver newCassowarySolver.
	solver2 := ConstraintSolver newCassowarySolver.

	self shouldnt: [[ex a = 42] alwaysSolveWith: solver] raise: Error.
	self should: [ex a = 42].
	self should: [(ex instVarAt: 1) solver == solver].

	self should: [[ex a = 17] alwaysSolveWith: solver2] raise: Error.	"The instance variable already uses another solver."
	self should: [ex a = 42].
	self should: [(ex instVarAt: 1) solver == solver].

	self shouldnt: [[ex b = 17] alwaysSolveWith: solver2] raise: Error.
	self should: [ex b = 17].
	self should: [(ex instVarAt: 2) solver == solver2].

	self should: [[ex a = ex b] alwaysSolveWith: solver] raise: Error.
	self should: [ex a = 42].
	self should: [ex b = 17].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/14/2014 14:34'!
testNoConstraintInBlock

	| ex solver |
	ex := ExampleClass new.
	ex a: 21; b: 42.
	solver := ConstraintSolver newCassowarySolver.

	self should: [[ex a = 1 & (ex b = 2). false] alwaysSolveWith: solver] raise: Error.
	self shouldnt: [ex a = 1].
	self shouldnt: [ex b = 2].
	self should: [solver constraints isEmpty].

	self should: [[ex a + ex b] alwaysSolveWith: solver] raise: Error.
	self should: [solver constraints isEmpty].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 5/8/2014 10:13'!
testPriorityChange

	| ex constraint |
	ex := ExampleClass new.
	constraint := [ex a = 42] alwaysTrue.

	self should: [constraint priority = ConstraintPriority required].
	self should: [ex a: 21] raise: ConstraintUnsatisfiableError.

	self shouldnt: [constraint priority: ConstraintPriority medium] raise: Error.
	self should: [constraint priority = ConstraintPriority medium].
	self shouldnt: [ex a: 21] raise: Error.
	! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/16/2014 12:02'!
testPriorityOrder

	| p1 p2 p3 p4 |
	p1 := ConstraintPriority required.
	p2 := ConstraintPriority strong.
	p3 := ConstraintPriority medium.
	p4 := ConstraintPriority weak.

	self should: [p1 <= p2].
	self should: [p2 <= p3].
	self should: [p3 <= p4].

	self should: [p1 < p2].
	self should: [p2 < p3].
	self should: [p3 < p4].

	self shouldnt: [p1 < p1].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/22/2014 15:50'!
testSimpleAssignmentConstraint

	| ex |
	ex := ExampleClass new.
	self shouldnt: [[ex a = 42] alwaysTrue.] raise: Error.
	self should: [ex a isNumber].
	self should: [ex a = 42].! !

TestCase subclass: #ConstraintsZ3Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/14/2014 10:40'!
testBoolConstraint

	| ex ex2 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[(ex a = ex b) = (ex2 a = ex2 b)] alwaysSolveWith: solver] raise: Error.
	self should: [(ex a = ex b) & (ex2 a = ex2 b) or: [(ex a ~= ex b) & (ex2 a ~= ex2 b)]].
	self should: [solver constraints size = 1].
	self should: [solver constraints first expressions size = 1].

	self shouldnt: [ex a: 21] raise: Error.
	self should: [(ex a = ex b) & (ex2 a = ex2 b) or: [(ex a ~= ex b) & (ex2 a ~= ex2 b)]].
	self should: [ex a = 21].

	self shouldnt: [[(ex a = ex b) = false] alwaysSolveWith: solver] raise: Error.
	self should: [ex a ~= ex b].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 15:43'!
testBuildProgram

	| ex constraint program |
	ex := ExampleClass new.
	self shouldnt: [constraint := [ex a = 42] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self shouldnt: [program := constraint solver buildProgram] raise: Error.
	self should: ['*(declare-fun a () Real)*(assert (= a 42))*(check-sat)*' match: program].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:35'!
testComplexConjunctionWithAnd

	| pt1 pt2 |
	pt1 := ExampleClass new.
	pt1 a: 20; b: 20.
	pt2 := ExampleClass new.
	pt2 a: 10; b: 10.

      self shouldnt: [[pt1 a = pt2 a and: [pt1 b = pt2 b]] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self should: [pt1 a = pt2 a].
	self should: [pt1 b = pt2 b].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:36'!
testComplexConjunctionWithAnd2

	| pt1 pt2 |
	pt1 := ExampleClass new.
	pt1 a: 20; b: 20.
	pt2 := ExampleClass new.
	pt2 a: 10; b: 10.

      self shouldnt: [[pt1 = pt2] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self should: [pt1 a = pt2 a].
	self should: [pt1 b = pt2 b].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/13/2014 15:30'!
testComplexExpressionWithMultiplication

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) * 3 = (ex2 a * 2 + (ex b - ex3 a * (-4)))] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].

	self shouldnt: [ex a: 1] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex a clApprox: 1].

	self shouldnt: [ex2 b: 2] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex2 b clApprox: 2].

	self shouldnt: [ex2 a: 4] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex2 a clApprox: 4].

	self shouldnt: [ex b: 5] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex b clApprox: 5].

	self shouldnt: [ex3 a: 6] raise: Error.
	self should: [(ex a - ex2 b) * 3 clApprox: (ex2 a * 2 + (ex b - ex3 a * (-4)))].
	self should: [ex3 a clApprox: 6].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 11:49'!
testComplexInequalityConstraints

	| ex ex2 constraint solver |
	ex := ExampleClass new.
	ex a: 15.
	ex b: 15.
	ex2 := ExampleClass new.
	ex2 a: 5.
	ex2 b: 5.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a <= 10] alwaysSolveWith: solver] raise: Error.
	self shouldnt: [[ex b >= 20] alwaysSolveWith: solver] raise: Error.
	self should: [[ex a = ex b] alwaysSolveWith: solver] raise: ConstraintUnsatisfiableError.

	self shouldnt: [[ex a <= ex2 a] alwaysSolveWith: solver] raise: Error.
	self shouldnt: [constraint := [ex2 a >= 20] alwaysSolveWith: solver] raise: Error.
	constraint disable.
	self shouldnt: [constraint := [ex2 a <= 5] alwaysSolveWith: solver] raise: Error.
	constraint disable.

	self shouldnt: [[ex b <= ex2 a] alwaysSolveWith: solver] raise: Error.
	self should: [[ex2 a <= 10] alwaysSolveWith: solver] raise: ConstraintUnsatisfiableError.! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 11:56'!
testComplexInequalityConstraintsWithExpressions

	| ex ex2 solver |
	ex := ExampleClass new.
	ex a: 15.
	ex b: 15.
	ex2 := ExampleClass new.
	ex2 a: 5.
	ex2 b: 5.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a + ex b <= 10] alwaysSolveWith: solver] raise: Error.
	self should: [ex a + ex b <= 10].

	self shouldnt: [[ex2 a + ex2 b >= 10] alwaysSolveWith: solver] raise: Error.
	self should: [ex2 a + ex2 b >= 10].
	
	self shouldnt: [[ex a + ex b < 20] alwaysSolveWith: solver] raise: Error.
	self should: [ex a + ex b < 20].

	self shouldnt: [[ex2 a + ex2 b > 15] alwaysSolveWith: solver] raise: Error.
	self should: [ex2 a + ex2 b > 15].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:37'!
testComplexLinearExpressionWithDivision

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) / 3.0 = (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].

	self shouldnt: [ex a: 1] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex a clApprox: 1].

	self shouldnt: [ex2 b: 2] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex2 b clApprox: 2].

	self shouldnt: [ex2 a: 4] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex2 a clApprox: 4].

	self shouldnt: [ex b: 5] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex b clApprox: 5].

	self shouldnt: [ex3 a: 6] raise: Error.
	self should: [(ex a - ex2 b) / 3.0 clApprox: (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))].
	self should: [ex3 a clApprox: 6].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:54'!
testConjunctionChain

	| ex ex2 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a = 1 & (ex b = 2) & (ex2 a = 3) & (ex2 b = 4)] alwaysSolveWith: solver] raise: Error.
	self should: [ex a = 1].
	self should: [ex b = 2].
	self should: [ex2 a = 3].
	self should: [ex2 b = 4].

	self should: [solver constraints size = 1].

	self should: [ex a: 21] raise: ConstraintUnsatisfiableError.
	self should: [ex b: 21] raise: ConstraintUnsatisfiableError.
	self should: [ex2 a: 21] raise: ConstraintUnsatisfiableError.
	self should: [ex2 b: 21] raise: ConstraintUnsatisfiableError.! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:56'!
testConjunctionError

	| ex solver |
	ex := ExampleClass new.
	ex a: 1.
	ex b: 1.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a = 3] alwaysSolveWith: solver] raise: Error.
	self should: [ex a = 3].
	self should: [ex b = 1].

	self should: [[(ex b = 2) & (ex a = 2)] alwaysSolveWith: solver] raise: ConstraintUnsatisfiableError.
	self should: [ex a = 3].
	self should: [ex b = 1].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:57'!
testConjunctionWithAnd

	| ex |
	ex := ExampleClass new.

      self shouldnt: [[ex a = 3 and: [ex b = 3]] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self should: [ex a = 3].
	self should: [ex b = 3].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 10:59'!
testConstraintObject

	| ex ex2 ex3 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	ex3 := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.

	self should: [([(ex a - ex2 b) + ex3 a = (ex2 a - (ex b + ex3 b))] alwaysSolveWith: solver) class == ConstraintZ3].
	self should: [([(ex a - ex2 b) * 3 = (ex2 a * 2 + (ex b - ex3 a * (-4)))] alwaysSolveWith: solver) class == ConstraintZ3].
	self should: [([(ex a - ex2 b) / 3.0 = (ex2 a / 2.0 + (ex b - ex3 a / (-4.0)))] alwaysSolveWith: solver) class == ConstraintZ3].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 11:14'!
testConstraintObjectInterface

	| ex constraint |
	ex := ExampleClass new.

	constraint := [ex a = 2] alwaysSolveWith: ConstraintSolver newZ3Solver.
	self should: [constraint isConstraint].

	self shouldnt: [constraint enable] raise: Error.	"Should print a Warning, because it is already enabled."
	self should: [ex a: 3] raise: ConstraintUnsatisfiableError.
	self should: [constraint solver constraints size = 1].

	self shouldnt: [constraint disable] raise: Error.
	self shouldnt: [ex a: 4] raise: Error.! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 16:38'!
testCosine

	| ex ex2 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a cos = 0] alwaysSolveWith: solver] raise: Error.
	self should: [ex a cos clApprox: 0].

	self shouldnt: [[ex b cos = 1] alwaysSolveWith: solver] raise: Error.
	self should: [ex b cos clApprox: 1].

	self shouldnt: [[(ex2 a + ex2 b) cos = 1] alwaysSolveWith: solver] raise: Error.
	self should: [(ex2 a + ex2 b) cos clApprox: 1].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/13/2014 15:20'!
testEqualityOfTwoVariables

	| ex ex2 |
	ex := ExampleClass new.
	ex a: 23.
	ex2 := ExampleClass new.
	ex2 a: 17.

	self shouldnt: [[ex a = ex2 a] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.
	self should: [ex a = ex2 a].

	self shouldnt: [ex2 a: 42] raise: Error.
	self should: [ex a = ex2 a].
	self should: [ex2 a = 42].

	self shouldnt: [ex a: 9] raise: Error.
	self should: [ex a = ex2 a].
	self should: [ex a = 9].

	self shouldnt: [ex2 a: 21] raise: Error.
	self should: [ex a = ex2 a].
	self should: [ex2 a = 21].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 15:44'!
testInequality

	| ex ex2 solver |
	ex := ExampleClass new.
	ex a: 15.
	ex b: 15.
	ex2 := ExampleClass new.
	ex2 a: 15.
	ex2 b: 15.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a <= 10] alwaysSolveWith: solver] raise: Error.
	self should: [ex a <= 10].

	self shouldnt: [ex a: 7] raise: Error.
	self should: [ex a = 7].

	self should: [ex a: 17] raise: ConstraintUnsatisfiableError.
	self should: [ex a = 7].

	self shouldnt: [[ex2 a < 10] alwaysSolveWith: solver] raise: Error.
	self should: [ex2 a < 10].

	self shouldnt: [ex2 a: 7] raise: Error.
	self should: [ex2 a = 7].

	self should: [ex2 a: 17] raise: ConstraintUnsatisfiableError.
	self should: [ex2 a = 7].

	self shouldnt: [[ex b >= 20] alwaysSolveWith: solver] raise: Error.
	self should: [ex b >= 20].

	self shouldnt: [ex b: 27] raise: Error.
	self should: [ex b = 27].

	self should: [ex b: 17] raise: ConstraintUnsatisfiableError.
	self should: [ex b = 27].

	self shouldnt: [[ex2 b > 20] alwaysSolveWith: solver] raise: Error.
	self should: [ex2 b > 20].

	self shouldnt: [ex2 b: 27] raise: Error.
	self should: [ex2 b = 27].

	self should: [ex2 b: 17] raise: ConstraintUnsatisfiableError.
	self should: [ex2 b = 27].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 11:16'!
testInstancevariableClass

	| ex ex2 ex3 |
	ex := ExampleClass new.
	ex a: 23.
	ex b: 24.
	ex2 := ExampleClass new.
	ex2 a: 17.
	ex2 b: 18.
	ex3 := ExampleClass new.
	ex3 a: 41.
	ex3 b: 42.

	self shouldnt: [[(ex a - ex2 b) + ex3 a = (ex b + ex3 b)] alwaysSolveWith: ConstraintSolver newZ3Solver] raise: Error.

	self should: [(ex instVarNamed: 'a') class == ConstraintZ3Variable].
	self should: [(ex instVarNamed: 'b') class == ConstraintZ3Variable].

	self shouldnt: [(ex2 instVarNamed: 'a') class == ConstraintZ3Variable].
	self should: [(ex2 instVarNamed: 'b') class == ConstraintZ3Variable].

	self should: [(ex3 instVarNamed: 'a') class == ConstraintZ3Variable].
	self should: [(ex3 instVarNamed: 'b') class == ConstraintZ3Variable].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 11:26'!
testNoConstraintInBlock

	| ex solver |
	ex := ExampleClass new.
	ex a: 21; b: 42.
	solver := ConstraintSolver newZ3Solver.

	self should: [[ex a = 1 & (ex b = 2). false] alwaysSolveWith: solver] raise: Error.
	self shouldnt: [ex a = 1].
	self shouldnt: [ex b = 2].
	self should: [solver constraints isEmpty].

	self should: [[ex a + ex b] alwaysSolveWith: solver] raise: ConstraintUnsatisfiableError.
	self should: [solver constraints isEmpty].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 16:42'!
testPower

	| ex ex2 ex3 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	ex3 := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[(ex a raisedTo: 2) = 9] alwaysSolveWith: solver] raise: Error.
	self should: [(ex a raisedTo: 2) = 9].
	self should: [ex a = 3].

	self shouldnt: [[(ex b raisedToInteger: 3) = 8] alwaysSolveWith: solver] raise: Error.
	self should: [(ex b raisedToInteger: 3) = 8].
	self should: [ex b = 2].

	self shouldnt: [[ex2 a squared = 16] alwaysSolveWith: solver] raise: Error.
	self should: [ex2 a squared = 16].
	self should: [ex2 a = 4 or: [ex2 a = -4]].

	self shouldnt: [[((ex3 a + ex3 b) squared) = 25] alwaysSolveWith: solver] raise: Error.
	self should: [((ex3 a + ex3 b) raisedTo: 2) = 25].! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/13/2014 15:29'!
testSimpleEqualityConstraint

	| ex solver |
	ex := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.
	self shouldnt: [[ex a = 42] alwaysSolveWith: solver] raise: Error.
	self should: [(ex instVarAt: 1) class == ConstraintZ3Variable].
	self should: [(ex instVarAt: 1) solver == solver].
	self should: [(ex instVarAt: 1) varName = 'a'].
	self should: [ex a = 42].

	self should: [ex a: 21] raise: ConstraintUnsatisfiableError.! !

!ConstraintsZ3Tests methodsFor: 'testing' stamp: 'mg 5/26/2014 16:41'!
testSine

	| ex ex2 solver |
	ex := ExampleClass new.
	ex2 := ExampleClass new.
	solver := ConstraintSolver newZ3Solver.

	self shouldnt: [[ex a sin = 1] alwaysSolveWith: solver] raise: Error.
	self should: [ex a sin clApprox: 1].
	self should: [ex a clApprox: Float halfPi].

	self shouldnt: [[ex b sin = 0] alwaysSolveWith: solver] raise: Error.
	self should: [ex b sin clApprox: 0].

	self shouldnt: [[(ex2 a + ex2 b) sin = 0] alwaysSolveWith: solver] raise: Error.
	self should: [(ex2 a + ex2 b) sin clApprox: 0].! !

TestCase subclass: #LinearExpressionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!LinearExpressionTests methodsFor: 'running' stamp: 'mg 5/13/2014 12:35'!
setUp

	| constraint |
	ConstraintSolver cassowarySolver removeAllConstraints.
	constraint := ConstraintCassowary new
					priority: ConstraintPriority required;
					solver: ConstraintSolver cassowarySolver;
					yourself.
	Processor activeProcess environmentAt: #constraintObject put: constraint.! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testAddition

	| var17 var23 expr expr2 |
	var17 := 17 asConstraintVariable.
	var23 := 23 asConstraintVariable.

	self should: [(var17 + var23) class == ConstraintLinearExpression].

	expr := 9 asConstraintVariable + 13 asConstraintVariable.
	self should: [(expr + var17) class == ConstraintLinearExpression].
	self should: [(var17 + expr) class == ConstraintLinearExpression].

	expr2 := 42 asConstraintVariable + 21 asConstraintVariable.
	self should: [(expr + expr2) class == ConstraintLinearExpression].

	self should: [(var17 + 2) class == ConstraintLinearExpression].

	self shouldnt: [TestUtilities solveConstraintExpression: (var23 + var17 = 42)] raise: Error.
	self should: [var23 value + var17 value = 42].! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testDivision

	| var17 var23 expr expr2 var21 |
	var17 := 17 asConstraintVariable.
	var21 := 21 asConstraintVariable.
	var23 := 23 asConstantConstraintVariable.

	self should: [(var17 / var23) class == ConstraintLinearExpression].
	self should: [(var17 / 3.0) class == ConstraintLinearExpression].

	expr := 9 asConstraintVariable / 13 asConstantConstraintVariable.
	self should: [(expr / var23) class == ConstraintLinearExpression].
	self should: [(expr / 3.0) class == ConstraintLinearExpression].

	expr2 := 42 asConstraintVariable / 3.0.
	self should: [(expr2 / var23) class == ConstraintLinearExpression].
	self should: [(expr2 / 5.0) class == ConstraintLinearExpression].

	self should: [expr / expr2] raise: Error.
	self should: [var17 / var21] raise: Error.
	self should: [expr / var21] raise: Error.
	self should: [var17 / expr2] raise: Error.

	self shouldnt: [TestUtilities solveConstraintExpression: (var17 / 3.0 = 42)] raise: Error.
	self should: [var17 value / 3.0 = 42].! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testEqualityExpressionsWithAddition

	| var13 var17 var9 var23 |
	var17 := 17 asConstraintVariable.
	var9 := 9 asConstraintVariable.
	var13 := 13 asConstraintVariable.
	var23 := 23 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: ((var17 + var9) = (var13 + var23))] raise: Error.
	self should: [(var17 value + var9 value) = (var13 value + var23 value)].

	! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testEqualityExpressionsWithSubtraction

	| var13 var17 var9 var23 |
	var17 := 17 asConstraintVariable.
	var9 := 9 asConstraintVariable.
	var13 := 13 asConstraintVariable.
	var23 := 23 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: ((var17 - var9) = (var23 - var13))] raise: Error.
	self should: [(var17 value - var9 value) = (var23 value - var13 value)].

	! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testEqualityVariableAndExpressionWithAddition

	| var13 var17 var9 |

	var17 := 17 asConstraintVariable.
	var9 := 9 asConstraintVariable.
	var13 := 13 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (var9 + var13 = var17)] raise: Error.
	self should: [var9 value + var13 value = var17 value].
	! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testEqualityVariableAndExpressionWithAddition2

	| var21 var42 var23 |

	var23 := 23 asConstraintVariable.
	var21 := 21 asConstraintVariable.
	var42 := 42 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (var42 = (var21 + var23))] raise: Error.
	self should: [var42 value = (var21 value + var23 value)].

	! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testEqualityVariableAndExpressionWithSubtraction

	| var13 var17 var9 |

	var17 := 17 asConstraintVariable.
	var9 := 9 asConstraintVariable.
	var13 := 13 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (var9 - var13 = var17)] raise: Error.
	self should: [var9 value - var13 value = var17 value].

	! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testEqualityVariableAndExpressionWithSubtraction2

	| var21 var42 var23 |

	var23 := 23 asConstraintVariable.
	var21 := 21 asConstraintVariable.
	var42 := 42 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (var42 = (var21 - var23))] raise: Error.
	self should: [var42 value = (var21 value - var23 value)].

	! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testMultiplication

	| var17 var23 expr expr2 var21 |
	var17 := 17 asConstraintVariable.
	var21 := 21 asConstraintVariable.
	var23 := 23 asConstantConstraintVariable.

	self should: [(var17 * var23) class == ConstraintLinearExpression].
	self should: [(var17 * 3) class == ConstraintLinearExpression].

	expr := 9 asConstraintVariable * 13 asConstantConstraintVariable.
	self should: [(expr * var23) class == ConstraintLinearExpression].
	self should: [(expr * 3) class == ConstraintLinearExpression].

	expr2 := 42 asConstraintVariable * 3.
	self should: [(expr2 * var23) class == ConstraintLinearExpression].
	self should: [(expr2 * 5) class == ConstraintLinearExpression].

	self should: [expr * expr2] raise: Error.
	self should: [var17 * var21] raise: Error.
	self should: [expr * var21] raise: Error.
	self should: [var17 * expr2] raise: Error.

	self shouldnt: [TestUtilities solveConstraintExpression: (var17 * 3 = 42)] raise: Error.
	self should: [var17 value * 3 = 42].! !

!LinearExpressionTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:05'!
testSubtraction

	| var17 var23 expr expr2 |
	var17 := 17 asConstraintVariable.
	var23 := 23 asConstraintVariable.

	self should: [(var17 - var23) class == ConstraintLinearExpression].

	expr := 9 asConstraintVariable + 13 asConstraintVariable.
	self should: [(expr - var17) class == ConstraintLinearExpression].
	self should: [(var17 - expr) class == ConstraintLinearExpression].

	expr2 := 42 asConstraintVariable + 21 asConstraintVariable.
	self should: [(expr - expr2) class == ConstraintLinearExpression].

	self should: [(var17 - 2) class == ConstraintLinearExpression].

	self shouldnt: [TestUtilities solveConstraintExpression: (var23 - var17 = 42)] raise: Error.
	self should: [var23 value - var17 value = 42].! !

TestCase subclass: #VariableTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!VariableTests methodsFor: 'running' stamp: 'mg 5/13/2014 12:35'!
setUp

	| constraint |
	ConstraintSolver cassowarySolver removeAllConstraints.
	constraint := ConstraintCassowary new
					priority: ConstraintPriority required;
					solver: ConstraintSolver cassowarySolver;
					yourself.
	Processor activeProcess environmentAt: #constraintObject put: constraint.! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorConstants

	| const2 const5 |
	const2 := 2 asConstantConstraintVariable.
	const5 := 5 asConstantConstraintVariable.

	self should: [const2 isConstant].
	self should: [const5 isConstant].

	self should: [TestUtilities solveConstraintExpression: (const2 = const5)] raise: ConstraintUnsatisfiableError.! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorConstants2

	| const9 |
	const9 := 9 asConstantConstraintVariable.

	self should: [const9 isConstant].

	self shouldnt: [TestUtilities solveConstraintExpression: (const9 = const9 copy)] raise: Error.! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorNilVariables

	| varNil varNil2 |
	varNil := ConstraintCassowaryVariable new.
	varNil2 := ConstraintCassowaryVariable new.

	self shouldnt: [TestUtilities solveConstraintExpression: (varNil = varNil2)] raise: Error.	"both values are nil"
	self should: [varNil value clApproxZero].
	self should: [varNil2 value clApproxZero].! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorOneVariable

	| const2 var17 varTest |
	var17 := ConstraintVariable newCassowaryVariableFor: 17.
	varTest := 'test' asConstraintVariable.
	const2 := 2 asConstantConstraintVariable.

	self should: [var17 isCassowaryVariable].
	self shouldnt: [varTest isCassowaryVariable].

	self shouldnt: [TestUtilities solveConstraintExpression: (var17 = const2)] raise: Error.	"var17 value notNil"
	self should: [var17 value = const2 value].! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorOneVariable2

	| const2 varNil |
	varNil := ConstraintCassowaryVariable new.
	const2 := 2 asConstantConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (varNil = const2)] raise: Error.	"varNil value isNil"	
	self should: [varNil value = const2 value].! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorOneVariable3

	| var23 |
	var23 := 23 asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (var23 = 47)] raise: Error.
	self should: [var23 value = 47].! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorTwoVariables

	| var17 var23 varTest |
	var17 := ConstraintVariable newCassowaryVariableFor: 17.
	var23 := 23 asConstraintVariable.
	varTest := 'test' asConstraintVariable.

	self shouldnt: [TestUtilities solveConstraintExpression: (var17 = var23)] raise: Error.	"values different, notNil"
	self should: [var17 value = var23 value].
	self should: [TestUtilities solveConstraintExpression: (var17 = varTest)] raise: Error.	"different variable types"! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/14/2014 13:06'!
testCassowaryVariableEqualityOperatorTwoVariables2

	| var23 varNil |
	var23 := 23 asConstraintVariable.
	varNil := ConstraintCassowaryVariable new.

	self shouldnt: [TestUtilities solveConstraintExpression: (var23 = varNil)] raise: Error. 	"varNil2 value isNil"
	self should: [var23 value = varNil value].! !

!VariableTests methodsFor: 'testing' stamp: 'mg 5/26/2014 15:47'!
testZ3VariablePrintDeclaration

	| z3IntVar z3RealVar z3BoolVar constraintZ3 |
	constraintZ3 := ConstraintZ3 new
						priority: ConstraintPriority required;
						solver: ConstraintSolver newZ3Solver;
						yourself.
	Processor activeProcess environmentAt: #constraintObject put: constraintZ3.

	z3IntVar := ConstraintZ3Solver constraintVariableFor: 17.
	z3IntVar varName: 'x'.
	self should: [z3IntVar printDeclaration = '(declare-fun x () Real)'].

	z3RealVar := ConstraintZ3Solver constraintVariableFor: 17.5.
	z3RealVar varName: 'y'.
	self should: [z3RealVar printDeclaration = '(declare-fun y () Real)'].

	z3BoolVar := ConstraintZ3Solver constraintVariableFor: true.
	z3BoolVar varName: 'z'.
	self should: [z3BoolVar printDeclaration = '(declare-fun z () Bool)'].! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 4/22/2014 13:32'!
doPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The
	 simulated receiver and arguments are given as arguments to this message.
	 If successful, push result and return resuming context, else ^ PrimitiveFailToken.
	 Any primitive which provokes execution needs to be intercepted and simulated
	 to avoid execution running away."
	<layer: #ccm>
	| value |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primtiive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[ToolSet 
			debugContext: self
			label:'Code simulation error'
			contents: nil].

	"ContextPart>>blockCopy:; simulated to get startpc right"
	(primitiveIndex = 80 and: [(self objectClass: receiver) includesBehavior: ContextPart]) 
		ifTrue: [^self push: ((BlockContext newForMethod: receiver method)
						home: receiver home
						startpc: pc + 2
						nargs: (arguments at: 1))].
	(primitiveIndex = 81 and: [(self objectClass: receiver) == BlockContext]) "BlockContext>>value[:value:...]"
		ifTrue: [^receiver pushArgs: arguments from: self].
	(primitiveIndex = 82 and: [(self objectClass: receiver) == BlockContext]) "BlockContext>>valueWithArguments:"
		ifTrue: [^receiver pushArgs: arguments first from: self].
	primitiveIndex = 83 "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		ifTrue: [^self send: arguments first
					to: receiver
					with: arguments allButFirst
					super: false].
	primitiveIndex = 84 "afr 9/11/1998 19:50 & eem 8/18/2009 17:04" "Object>>perform:withArguments:"
		ifTrue: [^self send: arguments first
					to: receiver
					with: (arguments at: 2)
					startClass: nil].
	primitiveIndex = 100 "eem 8/18/2009 16:57" "Object>>perform:withArguments:inSuperclass:"
		ifTrue: [^self send: arguments first
					to: receiver
					with: (arguments at: 2)
					startClass: (arguments at: 3)].

	"Mutex>>primitiveEnterCriticalSection
	 Mutex>>primitiveTestAndSetOwnershipOfCriticalSection"
	(primitiveIndex = 186 or: [primitiveIndex = 187]) ifTrue:
		[| active effective |
		 active := Processor activeProcess.
		 effective := active effectiveProcess.
		 "active == effective"
		 value := primitiveIndex = 186
					ifTrue: [receiver primitiveEnterCriticalSectionOnBehalfOf: effective]
					ifFalse: [receiver primitiveTestAndSetOwnershipOfCriticalSectionOnBehalfOf: effective].
		 ^((self objectClass: value) == Array
		    and: [value size = 2
		    and: [value first == PrimitiveFailToken]])
			ifTrue: [value]
			ifFalse: [self push: value]].

	primitiveIndex = 188 ifTrue: "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
		[^MethodContext
			sender: self
			receiver: receiver
			method: (arguments at: 2)
			arguments: (arguments at: 1)].

	"Closure primitives"
	(primitiveIndex = 200 and: [self == receiver]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: receiver
						startpc: pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].
	((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
	or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
		[^receiver simulateValueWithArguments: arguments caller: self].
	primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
		[^receiver simulateValueWithArguments: arguments first caller: self].

	primitiveIndex = 118 ifTrue: "tryPrimitive:withArgs:; avoid recursing in the VM"
		[(arguments size = 2
		 and: [arguments first isInteger
		 and: [(self objectClass: arguments last) == Array]]) ifFalse:
			[^ContextPart primitiveFailTokenFor: nil].
		 ^self doPrimitive: arguments first method: meth receiver: receiver args: arguments last].

	value := primitiveIndex = 120 "FFI method"
				ifTrue: [(meth literalAt: 1) tryInvokeWithArguments: arguments]
				ifFalse:
					[primitiveIndex = 117 "named primitives"
						ifTrue: [self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
						ifFalse:
							[receiver tryPrimitive: primitiveIndex withArgs: arguments]].
	^((self objectClass: value) == Array
	    and: [value size = 2
	    and: [value first == PrimitiveFailToken]])
		ifTrue: [value]
		ifFalse: [self push: (self valueOrConstraintVariableFor: meth receiver: receiver value: value)]! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 5/14/2014 13:54'!
jump: distance if: condition
	<layer: #ccm>
	| constraintExpr |
	(self top isConstraintExpression) ifTrue: [
		constraintExpr := self pop.
		constraintExpr addExpressionToConstraint: (Processor activeProcess environmentAt: #constraintObject).
		"self
			assert: (Processor activeProcess environmentAt: #constraintObject) == constraint
			description: 'Conjunction in jump:if: works when the top of stack is the current constraint object'."
		self push: true. "Do not jump -- assume the constraint expression can be satisfied"].
	^ self proceed: distance with: condition
! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 5/26/2014 16:11'!
send: selector super: superFlag numArgs: numArgs
	"Simulate the action of bytecodes that send a message with selector, 
	selector. The argument, superFlag, tells whether the receiver of the 
	message was specified with 'super' in the source method. The arguments 
	of the message are found in the top numArgs locations on the stack and 
	the receiver just below them."
	<layer: #ccm>
	| receiver arguments returnValue pair error |
	arguments := Array new: numArgs.
	numArgs to: 1 by: -1 do: [ :i | arguments at: i put: self pop].
	receiver := self pop.
	(receiver class category =  #'Constraints-Core' or: [receiver class category =  #'Cassowary-Kernel'])
		ifTrue: ["If we are inside the constraint solver, step to the outer context."
				(Array with: #ccm) deactivateLayersInCurrentProcess.
				QuickStep == self 
					ifTrue: [QuickStep := nil.
						returnValue := self quickSend: selector to: receiver with: arguments super: superFlag]
					ifFalse: [returnValue := self send: selector to: receiver with: arguments super: superFlag].
				pair := returnValue runUntilErrorOrReturnFrom: returnValue.	
				error := pair second.
				error ifNotNil: [Transcript show: 'There was an error during constraint construction. The message is: '; show: error messageText; cr. 
								error signal].
				(Array with: #ccm) activateLayersInCurrentProcess.
				^ pair first].
	selector = 'terminateProcess:' 
		ifTrue: [ returnValue := arguments first.
				(returnValue isConstraintExpression or: [returnValue = true])
					ifFalse: [self error: 'The constraint block did not return a constraint. Instead, it returned ', returnValue, '.'].
				returnValue isConstraintExpression 
					ifTrue: [returnValue addExpressionToConstraint: (Processor activeProcess environmentAt: #constraintObject)].
				Transcript show: 'process is terminating'; cr. ^ nil].
	QuickStep == self ifTrue:
		[QuickStep := nil.
		^self quickSend: selector to: receiver with: arguments super: superFlag].
	^self send: selector to: receiver with: arguments super: superFlag! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 5/13/2014 14:55'!
valueOrConstraintVariableFor: method receiver: receiver value: value
	<layer: #ccm>
	| setter cv |
	method isReturnField & method isMwMethodWrapper
		ifTrue: [	"use the existing constraint variable without replacement."
			Transcript show: 'found already wrapped instVar '; show: method selector; cr.
			cv := method unwrappedMethod valueWithReceiver: receiver arguments: #().
			cv solver ~= (Processor activeProcess environmentAt: #constraintObject) solver
				ifTrue: [	self error: 'The referenced instance variable is already constrained by another solver.']. 
			^ cv
			"The following code may be necessary to check whether the given value needs another solver. Then, raise an error."
			"cv := value asConstraintVariable.
			setter := method methodClass methodDict at: (method selector asString, ':') asSymbol.
			setter isMwMethodWrapper
				ifFalse: [self error: 'The getter is wrapped but the setter is not wrapped!!'].
			setter unwrappedMethod valueWithReceiver: receiver arguments: (Array with: cv)."].
	method isReturnField 
		ifTrue: [	"replace the corresponding instance variable with a constraint variable object."
			Transcript show: 'found instVar '; show: method selector; cr.
			cv := value asConstraintVariableForMethodName: method selector asString.
			setter := method methodClass methodDict at: (method selector asString, ':') asSymbol.
			setter unwrappedMethod valueWithReceiver: receiver arguments: (Array with: cv).
			"install method wrappers for the accessors, first create a subclass for the receiver"
			receiver class class == Metaclass ifTrue: [Transcript show: 'STOP'; cr. self error: 'Cannot mutate the Metaclass.'].
			(receiver class name includesSubString: 'a subclass of')
				ifFalse: [receiver class class basicNew
							superclass: (receiver class);
							setFormat: (receiver class format);
							methodDict: MethodDictionary new;
							adoptInstance: receiver].
			(ConstraintMethodWrapperForGetter on: method selector inClass: receiver class) 
				install.
			(ConstraintMethodWrapperForSetter on: setter selector inClass: receiver class)  
				getMethod: method unwrappedMethod;
				install.
			^ cv].
	^ value! !
